! mars 2019, XXX, passage en F90


!     ==========================================================================
      SUBROUTINE VECDOT(v1,v2,result)
!     ==========================================================================

!---------------------------------------------------------------------
! This subroutine send back the dot product of two vectors (in 3D)
!---------------------------------------------------------------------
      implicit none
      double precision v1,v2,result
      dimension v1(3),v2(3)
! ----------------------------------------------

      result = v1(1)*v2(1) + v1(2)*v2(2) + v1(3)*v2(3)

      RETURN
      END
!     ==========================================================================
! FIN SUBROUTINE
!     ==========================================================================




















!     ==========================================================================
      SUBROUTINE VECCRO(v1,v2,result)
!     ==========================================================================

!---------------------------------------------------------------------
! This subroutine send back the CROSS product of two vectors (in 3D)
!---------------------------------------------------------------------
      implicit none
      double precision v1,v2,result
      dimension v1(3),v2(3),result(3)
! ----------------------------------------------

      result(1) = v1(2)*v2(3) - v1(3)*v2(2)
      result(2) = v1(3)*v2(1) - v1(1)*v2(3)
      result(3) = v1(1)*v2(2) - v1(2)*v2(1)

      RETURN
      END
!     ==========================================================================
! FIN SUBROUTINE
!     ==========================================================================
















!     ==========================================================================
      SUBROUTINE ACOSSIN(cosi,sinu,result)
!     ==========================================================================

!---------------------------------------------------------------------
! This function returns an angle in [0,2pi[, the cosine of
! which is cosi, and the sinus of which is sinu
!---------------------------------------------------------------------
      implicit none
      double precision cosi,sinu,result
      double precision pi,angle
! ----------------------------------------------
      pi=4*dATan(1d0)

      if (sinu.ge.0) angle=dACOS(cosi)
      if (sinu.lt.0) angle=2*pi-dACOS(cosi)

! --- Si on est trop pres de pi ou de 0, on utilise plutot le arcsin
      if ( (dabs(sinu).lt.0.1d0).or.(dabs(cosi).gt.0.9d0) ) then
         if (cosi.ge.0) then
               angle=dASIN(sinu)
               if (angle.lt.0) angle=angle+2*pi
            endif
         if (cosi.lt.0) angle=pi-dASIN(sinu)
      endif

      result=angle

!      write(14,123),cosi,sinu,angle
! 123  format(1x,100(e18.9,1x))


      RETURN
      END
!     ==========================================================================
! FIN SUBROUTINE
!     ==========================================================================





















!     ==========================================================================
      SUBROUTINE COMPAL(d1M,d1P,d3P,result,mod)
!     ==========================================================================


!---------------------------------------------------------------------
! This function returns an angle in [0,2pi[ (mod=0) or in [-pi,pi[ (mod=1)
! from the three vectors d1M,d1P,d3M
! This is the alpha angle for a clamp rod
!---------------------------------------------------------------------
      implicit none
      integer mod
      double precision d1M,d1P,d3P,result
      double precision nord1m,nord1p,nord3p,cosal,vtemp,sinal,angle
      dimension d1M(3),d1P(3),d3P(3),vtemp(3)
      double precision pi
! ----------------------------------------------
      pi=4*dATan(1.0d0)

      call vecdot(d1M,d1M,nord1m)
      nord1m = dsqrt(nord1m)
      call vecdot(d1P,d1P,nord1p)
      nord1p = dsqrt(nord1p)
      call vecdot(d3P,d3P,nord3p)
      nord3p = dsqrt(nord3p)


!     voici le cosinus de l'angle
      call vecdot(d1M,d1P,cosal)
      cosal = cosal / nord1m / nord1p

!     voici le sinus de l'angle
      call veccro(d1M,d1P,vtemp)
      call vecdot(vtemp,d3P,sinal)
      sinal = sinal / nord1m / nord1p / nord3p

      call ACOSSIN(cosal,sinal,angle)

      if (mod.eq.1) then  ! si on veut un resultat dans [-pi ; pi[
        if (sinal.lt.0.0d0) angle=angle-2*pi
      endif
      result=angle

      RETURN
      END
!     ==========================================================================
! FIN SUBROUTINE
!     ==========================================================================
