! la loi de AUTO : NICP = NBC + NINT − NDIM + 1

# Default AUTO Constants file
# e=''      ! fichier equations (.f90)
# s=''        ! fichier type fort.8 avec lequel on redemarre la conti (IRS)
# dat='u_stpnt'  ! fichier avec une solution nonlineaire, pour demarrer IRS=0
# sv=''       ! fichier pour les sorties b.xxx s.xxx d.xxx

! unames = {1:'m1', 2:'m2', 3:'m3', 4:'x', 5:'y', 6:'z', ...}
parnames = {1:'n20', 2:'n30', 3:'m20', 4:'m30', 5:'eta0', 6:'unsurw', 7:'typepsi', 8:'typeconti', 9:'alphaL', 10:'Lk', 11:'Tw', 12:'Wr', 23:'unsureps'}

NMX =  2250   ! nombre de pas de conti
NPR =  9552   ! tous les n pas sort un fort.8
IRS =  021   ! label de redemarrage, si 0 faire STPNT et fichier dat

DS  =  0.01  ! arc length de depart
DSMIN= 0.0001 ! arc length minimum
DSMAX=   0.75 ! arc length maximum
IADS=   1    ! on modifie l arclength tous les n pas

NDIM = 18      ! dimension du vector field
NPAR = 24      ! nombre de parametres
ICP =  ['unsurw', 'n20', 'n30', 'm20', 'm30', 'eta0']    ! les parametres qui bougent
NBC =   23    ! nombre de conditions de bord

NTST=  70  ! nombre de segments sur (0;1)
NCOL=   5  ! degre du poly de lagrange (entre 3 et 7)
IAD =   3  ! =0 fixed mesh, =n adapt mesh tous les n pas

UZR =  {'unsurw': [6.2831853 10.0 12.5 15.707963 20 25 31.4159265 40 50.0 80 100.0 125 200.0 250 400 500.0 800 1000.0]}          ! format {'lambda': [0.5, 1.0]}
UZSTOP = {'unsurw':[-0.1,4.9,1000.1]}       ! meme format que UZR, mais la conti s arrete
SP = []           ! SP = ['UZ3'] : la conti s arrete au 3eme point UZR (marche pas bien je crois)

! =================================================
! en general, on change rien en dessous ===========
! =================================================

ITMX= 9  ! nbr d'iter pour rafiner usr points ou bif points
ITNW= 12  ! n iter max de newton
NWTN= 4  ! n iter avant blocage du jacobien (chord method)
JAC= 0   ! on ne fournit rien du jacobien

EPSL = 1e-07  ! precision newton sur les param
EPSU = 1e-07  ! precision newton sur les variables
EPSS = 1e-05  ! precision sur l arclength

ILP =   0  ! no detection of fold
ISP =   0  ! =0 pas de detection bif, =2 detection bif
ISW =   1  ! =1 normal, =-1 on switch sur la branche bifurquee
IIS =   0  ! =0 : fort.8 ne contient pas la tangente, =3 la tangente est presente (necessaire quand on switche)

IID =   2  ! level of info of the d.xxx file (fort.9)
IPS =   4  ! 4 : BVP
IPLT=   0  ! =0 printer L2norm dans fort7, =n print d autres trucs
NINT=   0  ! nombre de conditions integrales
MXBF=  10  ! seulement pour les problemes algebriques

THL =  {}  ! si on veut enlever certains param du calcul du arclength
THU =  {}  ! si on veut enlever certaines variables du calcul du arclength

IBR=0  ! numero initial des branches
LAB=0  ! numero initial des label
TY=''  ! si on veut changer l etiquette du point de redemarrage

STOP = []  ! c est un peu comme SP
